<!DOCTYPE html>
<html>
<head>
  <title>OpenERP Runbot - ${team_name}</title>
  <link rel="shortcut icon" href="/favicon.ico" />
  <link rel="stylesheet" href="css/runbot.css" type="text/css">
  <script src="js/jquery-1.7.1.min.js"></script>
  <script src="js/dropdown.js"></script>
  <script src="js/runbot.js"></script>
</head>
<body>

<%namespace name="defs" file="defs.html.mako"/>

  <div class="container">

    <div class="topbar">
      <ul class="nav">
        <li><a href="/"><img src="img/logo.png" alt="" class="png"></a> </li>
        <li class="dropdown" data-dropdown="dropdown">
          <a href="#" class="dropdown-toggle">Teams</a>
          <ul class="dropdown-menu">
% for tname in r.teams_with_branches():
  % if tname == 'openerp-dev':
    <li><a href="/">${tname}</a></li>
  % else:
    <li><a href="/${tname}.html">${tname}</a></li>
  % endif
% endfor
          </ul>
        </li>
        <li><a href="#the-queue">Queue (${len(r.get_queue())})</a> </li>
        <li><a href="#">About</a> </li>
      </ul>
      <div class="clear"></div>
    </div>

    <h1>${team_name}</h1>

    <div class="pane" id="about">
      <h2>About</h2>
<p>The OpenERP Runbot is a simple yet useful Integration Server tailored for the
different OpenERP branches available through
<a href="http://www.launchpad.net">Launchpad</a>. It runs branches from our
partners and the core team. If you are a partner, you should be able to
register your team or branches from your Partner Portal. You can also
<a href="#code">grab a copy</a> and run it yourself.</p>

<p>Please note this is a static page, re-generated regularly. Any operation (e.g.
build) may not give an immediate feedback.</p>

<p>The Runbot maintains ${r.number} concurrent branches. The branches are, in
order of priority, the sticky ones, then the ones with a manual build request,
then the others. For the 'sticky' and 'others', their last commit date is used
to sort them.</p>

<h2 id="code">Source code</h2>
<p>The complete source code for this Runbot is available on Launchpad:
<a href="https://launchpad.net/openerp-tools">launchpad.net/openerp-tools</a>
(in the <code>openerp-runbot</code> sub-directory), where you can also fill
bug reports or propose your patches.</p>
    </div>

% if r.nginx_groups_sticky(team_name):
    <div class="pane" id="sticky">
      <h2>Sticky Branches</h2>
      <table cellspacing="0">
% for i in r.nginx_groups_sticky(team_name):
    ${defs.short_row_(r,i)}
% endfor
      </table>
    </div>
% endif

% if r.nginx_groups_others(team_name):
    <div class="pane" id="others">
      <!--<input class="searchbox" placeholder="Search branches...">-->
      <h2>Development Branches</h2>
      <table cellspacing="0">
% for i in r.nginx_groups_others(team_name):
    ${defs.short_row_(r,i)}
% endfor
      </table>
    </div>
% endif

    <div id="the-queue" class="pane">
<h2>Queue (${len(r.get_queue())} items)</h2>
<table>
% for i in r.get_queue():
    ${defs.simple_row(r,i)}
% endfor
</table>
    </div>

    <div class="pane" id="registered">
<h2>Registered branches (not processed)</h2>
<table class="index registered-branches">
% for i in r.nginx_groups_registered(team_name):
    ${defs.simple_row(r,i)}
% endfor
</table>
    </div>

    <div class="pane" id="runtime">
      <h2>Runtime data</h2>
        <div class="stats">
        (The following data are global to the Runbot.)<br />
        Default job type: ${r.default_job_type}.<br />
        Maximum ${r.number} concurrent branches.<br />
        Maximum ${r.workers} concurrent jobs.<br />
        ${r.current_job_id} processed jobs.<br />
        ${r.workers - r.available_workers()} ongoing jobs.<br />
        ${r.next_build_number} manual build requests to go.<br />
        </div>
    </div>

  </div>

</body>
</html>
