<%def name="rev_(r,g,b,p)">
  <li>
% if b.project_name in p.need_run_reason:
  <span class="reason">
% else:
  <span>
% endif
  <a href="http://bazaar.launchpad.net/${b.unique_name}/revision/${b.local_revision_count}">${b.project_name} (${b.local_revision_count})</a>
  </span></li>
</%def>

<%def name="point_(r,g,p)">
          <td id="${p.job_id}">
            <div><span class="icon-cog action-toggle dropdown-toggle" data-toggle="dropdown"></span>
    <ul class="dropdown-menu dd-info">
        <li><a href="/${p.subdomain}/logs/">
        % if p.test_result:
            Install logs (${p.test_result})
        % else:
            Install logs (ongoing)
        % endif
        </a></li>
        <li>NET-RPC port: ${r.server_net_port+p.port}</li>
        <li>XML-RPC port: ${r.server_xml_port+p.port}</li>
        % if 'build' in p.need_run_reason:
          <li>(Build manually requested)</li>
        % endif
        % if p.build_number != sys.maxint:
              <li>(${p.build_number})</li>
        % endif
    </ul></div>
    <p class="status-container">
% if p.state == 'testing':
            <span class="status testing"> </span>
% elif p.test_result:
            <span class="status ${p.test_result}"> </span>
% else:
            <span class="status"> </span>
% endif
% if p.state == 'testing':
	<span class="testing">Testing...</span>
% elif p.state == 'pulling':
	<span class="testing">Pulling...</span>
% elif p.state == 'allocated':
	<span class="testing">Allocated...</span>
% elif p.state == 'broken' or p.test_result == 'broken':
	<span class="icon-bomb">Internal error</span>
% elif p.test_result == 'killed':
    <span class="icon-skull">(too long)</span>
% elif p.running_since and p.test_result:
	<span class="running-long">${r.nginx_index_time(t-p.running_since)} ago</span>
% elif p.running_since:
	<span class="testing">${r.nginx_index_time(t-p.running_since)} ago</span>
% else:
	<span class="testing">Internal error</span>
% endif
</p>
<a href="#${p.job_id}">(Build ${p.job_id})</a>
            <ul>
% for b in p.repo_updates:
    ${rev_(r,g,b,p)}
% endfor
            </ul>
% if p.running_server_pid and p.running_since:
    <form target="_blank" method="GET" action="http://${p.db_prefix}.${r.domain}/">
        <button type="submit">Connect</button><button class="btn-connect-extra dropdown-toggle" data-toggle="dropdown">&nbsp;</button>
        <ul class="dropdown-menu dd-connect">
          <li><a href="http://${p.db_prefix}-base.${r.domain}/">Base install</a></li>
          <li><a href="http://${p.db_prefix}-all.${r.domain}/">All addons</a></li>
        </ul>
    </form>
% else:
            <p><button disabled="disabled">Disabled</button></p>
% endif
          </td>
</%def>

<%def name="branch_(r,g,b)">
% if not b.trigger_build:
<span class="label">
% else:
<span class="label notice">
% endif
<a href="http://code.launchpad.net/${b.unique_name}">${b.project_name}</a>
% if b.merge_count:
<a href="https://code.launchpad.net/${b.unique_name}/+activereviews">(${b.merge_count} mp)</a>
% endif
</span>
</%def>

<%def name="build_button_(r, g)">
<form method="POST" action="/a?build=${g.name}&amp;team=${g.team_name}">
    <button type="submit">Force Build</button>
</form>
</%def>

<%def name="short_row_(r,g)">
        <tr>
          <th>
            <p>${g.name}</p>
% for b in g.repo_updates():
    ${branch_(r,g,b)}
% endfor
% if g.wrong_matching:
  <span class="wrong-matching">These branches are not correctly named (<a href="/#how">see the instructions</a>).</span>
% endif
% if g.build_number != sys.maxint:
<p><span>(build n.${g.build_number})</span></p>
% elif not g.sticky:
    ${build_button_(r, g)}
% endif
<% bug=re.search('bug-([0-9]+)-',g.name) %>
% if bug:
    <p>bug: <a href="https://bugs.launchpad.net/bugs/${bug.group(1)}">lp:${bug.group(1)}</a></p>
% endif
<% bug=re.search('opw-([0-9]+)-',g.name) %>
% if bug:
    <p>ticket: <span>${bug.group(1)}</span></p>
% endif
          </th>
% for p in reversed(g.points):
%   if p:
      ${point_(r,g,p)}
%   else:
      <td></td>
%   endif
% endfor
        </tr>
</%def>


<%def name="simple_row(r,g)">
<tr>
    <td>
<form method="POST" action="/a?build=${g.name}&amp;team=${g.team_name}">
% if g.build_number != sys.maxint:
<strong>${g.build_number}.</strong>
% endif
${g.name}
<span>(${g.team_name})</span>
% if g.build_number == sys.maxint:
    <button type="submit">Force Build</button>
% endif
% for b in g.repo_updates():
    % if b.trigger_build:
        ${branch_(r,g,b)}
    % endif
% endfor
<% bug=re.search('bug-([0-9]+)-',g.name) %>
% if bug:
    bug: <a href="https://bugs.launchpad.net/bugs/${bug.group(1)}">lp:${bug.group(1)}</a>
% endif
<% bug=re.search('opw-([0-9]+)-',g.name) %>
% if bug:
    ticket: <span>${bug.group(1)}</span>
% endif
</form>
    </td>
</tr>
</%def>

