pid nginx/nginx.pid;
error_log nginx/error.log;
worker_processes  1;
events { worker_connections  1024; }
http {
    include /etc/nginx/mime.types;
    server_names_hash_max_size 512;
    server_names_hash_bucket_size 256;
    autoindex on;
    client_body_temp_path nginx;
    proxy_temp_path nginx;
    fastcgi_temp_path nginx;
    access_log nginx/access.log;
    index index.html;

    % for g in r.groups.values():
    % for i in g.points:
    % if i and (i.job_id > r.current_job_id - r.number or g.is_sticky_job(i)) and i.running_since:
        % if i.team_name == 'openerp-dev' and g.is_sticky_job(i):
        server { # openerp-dev sticky job (i.e. first job of a sticky branch)
          listen ${r.nginx_port};
          server_name ${i.name_underscore}.${r.domain};
          gzip on;
          gzip_types text/css text/plain application/xml application/json application/javascript;
          location / {
            proxy_read_timeout 600;
            proxy_connect_timeout 600;
            % if i.version == '6.0':
            proxy_pass http://127.0.0.1:${r.client_web_port+i.port}; # ${i.name_underscore}.${r.domain}
            % else:
            proxy_pass http://127.0.0.1:${r.server_xml_port+i.port}; # ${i.name_underscore}.${r.domain}
            % endif
            proxy_set_header X-Forwarded-Host $host;
            proxy_set_header Host $host;
          }
          location /longpolling {
            proxy_read_timeout 600;
            proxy_connect_timeout 600;
            proxy_pass http://127.0.0.1:${r.server_longpolling_port+i.port}; # ${i.name_underscore}.${r.domain}
            proxy_set_header X-Forwarded-Host $host;
            proxy_set_header Host $host;
          }
        }
        % endif

    server {
      listen ${r.nginx_port};
      server_name ${i.db_prefix}.${r.domain} ${i.db_prefix}-base.${r.domain} ${i.db_prefix}-all.${r.domain};
      gzip on;
      gzip_types text/css text/plain application/xml application/json application/javascript;
      location / {
        proxy_read_timeout 600;
        proxy_connect_timeout 600;
        % if i.version == '6.0':
        proxy_pass http://127.0.0.1:${r.client_web_port+i.port}; # ${i.db_prefix}.${r.domain}
        % else:
        proxy_pass http://127.0.0.1:${r.server_xml_port+i.port}; # ${i.db_prefix}.${r.domain}
        % endif
        proxy_set_header X-Forwarded-Host $host;
        proxy_set_header Host $host;
      }
      location /longpolling {
        proxy_read_timeout 600;
        proxy_connect_timeout 600;
        proxy_pass http://127.0.0.1:${r.server_longpolling_port+i.port}; # ${i.db_prefix}.${r.domain}
        proxy_set_header X-Forwarded-Host $host;
        proxy_set_header Host $host;
      }
    }
    % endif
    % endfor
    % endfor
    server {
       listen ${r.nginx_port} default;
       server_name ${r.domain};
       root ./static;
       location /a/ { proxy_pass http://127.0.0.1:${r.nginx_port - 1}; proxy_set_header X-Forwarded-Host $host; }
       location = /a { proxy_pass http://127.0.0.1:${r.nginx_port - 1}; proxy_set_header X-Forwarded-Host $host; }
       location /hostname/ { proxy_pass http://127.0.0.1:${r.nginx_port - 1}; proxy_set_header X-Forwarded-Host $host; }
       location = /hostname { proxy_pass http://127.0.0.1:${r.nginx_port - 1}; proxy_set_header X-Forwarded-Host $host; }
    }
}
